osgPresentation::SlideShowConstructor Class Reference

`#include <SlideShowConstructor>`

## Classes

struct | PositionData
struct | ModelData
struct | ImageData
struct | VolumeData
struct | FontData
struct | ScriptData

## Public Types

enum | CoordinateFrame { SLIDE , MODEL }
enum | ScriptCallbackType { UPDATE_SCRIPT , EVENT_SCRIPT }
enum | PresentationContext { CURRENT_PRESENTATION , CURRENT_SLIDE , CURRENT_LAYER }
typedef std::pair< ScriptCallbackType, std::string > | ScriptPair

## Public Member Functions

LayerAttributes * | getOrCreateLayerAttributes (osg::Node *node)
void | setDuration (osg::Node *node, double duration)
void | addKey (osg::Node *node, const KeyPosition &kp)
void | addRunString (osg::Node *node, const std::string &runString)
void | setJump (osg::Node *node, const JumpData &jumpData)
void | addPresentationKey (const KeyPosition &kp)
void | addPresentationRunString (const std::string &runString)
void | addSlideKey (const KeyPosition &kp)
void | addSlideRunString (const std::string &runString)
void | setSlideJump (const JumpData &jumpData)
void | addLayerKey (const KeyPosition &kp)
void | addLayerRunString (const std::string &runString)
void | setLayerJump (const JumpData &jumpData)
| SlideShowConstructor (osgDB::Options *options)
void | createPresentation ()
void | setBackgroundColor (const osg::Vec4 &color, bool updateClearNode)
const osg::Vec4 & | getBackgroundColor () const
void | setTextColor (const osg::Vec4 &color)
const osg::Vec4 & | getTextColor () const
void | setPresentationName (const std::string &name)
void | setPresentationAspectRatio (float aspectRatio)
void | setPresentationAspectRatio (const std::string &str)
void | setPresentationDuration (double duration)
void | addScriptEngine (const std::string &scriptEngineName)
void | addScriptFile (const std::string &name, const std::string &filename)
void | addScript (const std::string &name, const std::string &language, const std::string &script)
void | addSlide ()
void | selectSlide (int slideNum)
void | setSlideTitle (const std::string &name, PositionData &positionData, FontData &fontData)
void | setSlideBackgrondHUD (bool hud)
void | setSlideBackground (const std::string &name)
void | setSlideDuration (double duration)
Timeout * | addTimeout ()
void | addLayer (bool inheritPreviousLayers=true, bool defineAsBaseLayer=false)
void | selectLayer (int layerNum)
void | setLayerDuration (double duration)
FontData & | getTitleFontData ()
FontData & | getTitleFontDataDefault ()
PositionData & | getTitlePositionData ()
PositionData & | getTitlePositionDataDefault ()
FontData & | getTextFontData ()
FontData & | getTextFontDataDefault ()
PositionData & | getTextPositionData ()
PositionData & | getTextPositionDataDefault ()
void | translateTextCursor (const osg::Vec3 &delta)
PositionData & | getImagePositionData ()
PositionData & | getImagePositionDataDefault ()
PositionData & | getModelPositionData ()
PositionData & | getModelPositionDataDefault ()
void | addEventHandler (PresentationContext presentationContext, osg::ref_ptr< osgGA::GUIEventHandler > handler)
void | keyToDoOperation (PresentationContext presentationContext, int key, Operation operation, const JumpData &jumpData=JumpData())
void | keyToDoOperation (PresentationContext presentationContext, int key, const std::string &command, Operation operation, const JumpData &jumpData=JumpData())
void | keyEventOperation (PresentationContext presentationContext, int key, const KeyPosition &keyPos, const JumpData &jumpData=JumpData())
void | layerClickToDoOperation (Operation operation, const JumpData &jumpData=JumpData())
void | layerClickToDoOperation (const std::string &command, Operation operation, const JumpData &jumpData=JumpData())
void | layerClickEventOperation (const KeyPosition &keyPos, const JumpData &jumpData=JumpData())
void | addPropertyAnimation (PresentationContext presentationContext, PropertyAnimation *propertyAnimation)
void | addScriptCallback (PresentationContext presentationContext, ScriptCallbackType scriptCallbackType, const std::string &functionName)
void | addScriptToNode (ScriptCallbackType scriptCallbackType, const std::string &name, osg::Node *node)
void | addScriptsToNode (const ScriptData &scriptData, osg::Node *node)
void | addToCurrentLayer (osg::Node *subgraph)
void | addBullet (const std::string &bullet, PositionData &positionData, FontData &fontData, const ScriptData &scriptData)
void | addParagraph (const std::string &paragraph, PositionData &positionData, FontData &fontData, const ScriptData &scriptData)
osg::ref_ptr< osg::Image > | readImage (const std::string &filename, const ImageData &imageData)
void | addImage (const std::string &filename, const PositionData &positionData, const ImageData &imageData, const ScriptData &scriptData)
void | addStereoImagePair (const std::string &filenameLeft, const ImageData &imageDataLeft, const std::string &filenameRight, const ImageData &imageDataRight, const PositionData &positionData, const ScriptData &scriptData)
void | addGraph (const std::string &filename, const PositionData &positionData, const ImageData &imageData, const ScriptData &scriptData)
void | addVNC (const std::string &filename, const PositionData &positionData, const ImageData &imageData, const std::string &password, const ScriptData &scriptData)
void | addBrowser (const std::string &filename, const PositionData &positionData, const ImageData &imageData, const ScriptData &scriptData)
void | addPDF (const std::string &filename, const PositionData &positionData, const ImageData &imageData, const ScriptData &scriptData)
osg::ref_ptr< osg::Image > | addInteractiveImage (const std::string &filename, const PositionData &positionData, const ImageData &imageData, const ScriptData &scriptData)
void | addModel (osg::Node *subgraph, const PositionData &positionData, const ModelData &modelData, const ScriptData &scriptData)
void | addModel (const std::string &filename, const PositionData &positionData, const ModelData &modelData, const ScriptData &scriptData)
void | setUpVolumeScalarProperty (osgVolume::VolumeTile *tile, osgVolume::ScalarProperty *property, const std::string &source)
void | addVolume (const std::string &filename, const PositionData &positionData, const VolumeData &volumeData, const ScriptData &scriptData)
osg::Group * | takePresentation ()
osg::Group * | getPresentation ()
osg::Switch * | getPresentationSwitch ()
osg::Switch * | getCurrentSlide ()
void | pushCurrentLayer (osg::Group *newLayerGroup)
void | popCurrentLayer ()
osg::Group * | getCurrentLayer ()
void | setLoopPresentation (bool loop)
bool | getLoopPresentation () const
void | setAutoSteppingActive (bool flag=true)
bool | getAutoSteppingActive () const
void | setHUDSettings (HUDSettings *hudSettings)
HUDSettings * | getHUDSettings ()
const HUDSettings * | getHUDSettings () const
osg::ScriptEngine * | getOrCreateScriptEngine (const std::string &language)

## Protected Types

typedef std::map< std::string, osg::ref_ptr< osg::ScriptEngine > > | ScriptEngineMap
typedef std::map< std::string, osg::ref_ptr< osg::Script > > | ScriptMap
typedef std::vector< osg::ref_ptr< osg::Group > > | LayerStack
typedef std::list< osg::ref_ptr< osgGA::GUIEventHandler > > | EventHandlerList

## Protected Member Functions

void | findImageStreamsAndAddCallbacks (osg::Node *node)
osg::Geometry * | createTexturedQuadGeometry (const osg::Vec3 &pos, const osg::Vec4 &rotation, float width, float height, osg::Image *image, bool &usedTextureRectangle)
void | setUpMovieVolume (osg::Node *subgraph, osg::ImageStream *imageStream, const ImageData &imageData)
osg::Vec3 | computePositionInModelCoords (const PositionData &positionData) const
void | updatePositionFromInModelCoords (const osg::Vec3 &vertex, PositionData &positionData) const
osg::Vec3 | convertSlideToModel (const osg::Vec3 &position) const
osg::Vec3 | convertModelToSlide (const osg::Vec3 &position) const
osg::AnimationPathCallback * | getAnimationPathCallback (const PositionData &positionData)
osg::Node * | attachMaterialAnimation (osg::Node *model, const PositionData &positionData)
bool | attachTexMat (osg::StateSet *stateset, const ImageData &imageData, float s, float t, bool textureRectangle)
osg::StateSet * | createTransformStateSet ()
osg::Node * | decorateSubgraphForPosition (osg::Node *node, PositionData &positionData)
osg::Node * | decorateSubgraphForPositionAndAnimation (osg::Node *node, const PositionData &positionData)
std::string | findFileAndRecordPath (const std::string &filename)
void | recordOptionsFilePath (const osgDB::Options *options)

## Protected Attributes

osg::ref_ptr< osgDB::Options > | _options
osg::Vec3 | _slideOrigin
osg::Vec3 | _eyeOrigin
double | _slideWidth
double | _slideHeight
double | _slideDistance
unsigned int | _leftEyeMask
unsigned int | _rightEyeMask
osg::ref_ptr< HUDSettings > | _hudSettings
FontData | _titleFontData
FontData | _titleFontDataDefault
PositionData | _titlePositionData
PositionData | _titlePositionDataDefault
FontData | _textFontData
FontData | _textFontDataDefault
PositionData | _textPositionData
PositionData | _textPositionDataDefault
PositionData | _imagePositionData
PositionData | _imagePositionDataDefault
PositionData | _modelPositionData
PositionData | _modelPositionDataDefault
bool | _loopPresentation
bool | _autoSteppingActive
osg::Vec4 | _backgroundColor
std::string | _presentationName
double | _presentationDuration
osg::ref_ptr< osgPresentation::PropertyManager > | _propertyManager
osg::ref_ptr< osgPresentation::PropertyEventCallback > | _propertyEventCallback
osg::ref_ptr< osg::Group > | _root
osg::ref_ptr< osg::Switch > | _presentationSwitch
ScriptEngineMap | _scriptEngines
ScriptMap | _scripts
osg::ref_ptr< osg::ClearNode > | _slideClearNode
osg::ref_ptr< osg::Switch > | _slide
std::string | _slideTitle
std::string | _slideBackgroundImageFileName
bool | _slideBackgroundAsHUD
osg::ref_ptr< osg::Group > | _previousLayer
osg::ref_ptr< osg::Group > | _currentLayer
LayerStack | _layerStack
osg::ref_ptr< FilePathData > | _filePathData
osg::ref_ptr< osg::Group > | _layerToApplyEventCallbackTo
EventHandlerList | _currentEventCallbacksToApply

## Member Typedef Documentation

## EventHandlerList

typedef std::list< osg::ref_ptr<osgGA::GUIEventHandler> > osgPresentation::SlideShowConstructor::EventHandlerList

protected

## LayerStack

typedef std::vector< osg::ref_ptr<osg::Group> > osgPresentation::SlideShowConstructor::LayerStack

protected

## ScriptEngineMap

typedef std::map< std::string, osg::ref_ptr<osg::ScriptEngine> > osgPresentation::SlideShowConstructor::ScriptEngineMap

protected

## ScriptMap

typedef std::map< std::string, osg::ref_ptr<osg::Script> > osgPresentation::SlideShowConstructor::ScriptMap

protected

## ScriptPair

typedef std::pair<ScriptCallbackType, std::string> osgPresentation::SlideShowConstructor::ScriptPair

## Member Enumeration Documentation

## CoordinateFrame

enum osgPresentation::SlideShowConstructor::CoordinateFrame

Enumerator
SLIDE |
MODEL |

## PresentationContext

enum osgPresentation::SlideShowConstructor::PresentationContext

Enumerator
CURRENT_PRESENTATION |
CURRENT_SLIDE |
CURRENT_LAYER |

## ScriptCallbackType

enum osgPresentation::SlideShowConstructor::ScriptCallbackType

Enumerator
UPDATE_SCRIPT |
EVENT_SCRIPT |

## Constructor & Destructor Documentation

## SlideShowConstructor()

osgPresentation::SlideShowConstructor::SlideShowConstructor | ( | osgDB::Options * | options | ) |

Referenced by osgPresentation::SlideShowConstructor::PositionData::PositionData().

## Member Function Documentation

## addBrowser()

void osgPresentation::SlideShowConstructor::addBrowser | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ImageData & | imageData,
|  | const ScriptData & | scriptData )

## addBullet()

void osgPresentation::SlideShowConstructor::addBullet | ( | const std::string & | bullet,
|  | PositionData & | positionData,
|  | FontData & | fontData,
|  | const ScriptData & | scriptData )

## addEventHandler()

void osgPresentation::SlideShowConstructor::addEventHandler | ( | PresentationContext | presentationContext,
|  | osg::ref_ptr< osgGA::GUIEventHandler > | handler )

## addGraph()

void osgPresentation::SlideShowConstructor::addGraph | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ImageData & | imageData,
|  | const ScriptData & | scriptData )

## addImage()

void osgPresentation::SlideShowConstructor::addImage | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ImageData & | imageData,
|  | const ScriptData & | scriptData )

## addInteractiveImage()

osg::ref_ptr< osg::Image > osgPresentation::SlideShowConstructor::addInteractiveImage | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ImageData & | imageData,
|  | const ScriptData & | scriptData )

## addKey()

void osgPresentation::SlideShowConstructor::addKey | ( | osg::Node * | node,
|  | const KeyPosition & | kp )

inline

References getOrCreateLayerAttributes().

Referenced by addLayerKey(), addPresentationKey(), and addSlideKey().

## addLayer()

void osgPresentation::SlideShowConstructor::addLayer | ( | bool | inheritPreviousLayers = true,
|  | bool | defineAsBaseLayer = false )

Referenced by addLayerKey(), addLayerRunString(), and setLayerJump().

## addLayerKey()

void osgPresentation::SlideShowConstructor::addLayerKey | ( | const KeyPosition & | kp | ) |

inline

References _currentLayer, addKey(), and addLayer().

## addLayerRunString()

void osgPresentation::SlideShowConstructor::addLayerRunString | ( | const std::string & | runString | ) |

inline

References _currentLayer, addLayer(), and addRunString().

## addModel() [1/2]

void osgPresentation::SlideShowConstructor::addModel | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ModelData & | modelData,
|  | const ScriptData & | scriptData )

## addModel() [2/2]

void osgPresentation::SlideShowConstructor::addModel | ( | osg::Node * | subgraph,
|  | const PositionData & | positionData,
|  | const ModelData & | modelData,
|  | const ScriptData & | scriptData )

## addParagraph()

void osgPresentation::SlideShowConstructor::addParagraph | ( | const std::string & | paragraph,
|  | PositionData & | positionData,
|  | FontData & | fontData,
|  | const ScriptData & | scriptData )

## addPDF()

void osgPresentation::SlideShowConstructor::addPDF | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ImageData & | imageData,
|  | const ScriptData & | scriptData )

## addPresentationKey()

void osgPresentation::SlideShowConstructor::addPresentationKey | ( | const KeyPosition & | kp | ) |

inline

References _presentationSwitch, addKey(), and createPresentation().

## addPresentationRunString()

void osgPresentation::SlideShowConstructor::addPresentationRunString | ( | const std::string & | runString | ) |

inline

References _presentationSwitch, addRunString(), and createPresentation().

## addPropertyAnimation()

void osgPresentation::SlideShowConstructor::addPropertyAnimation | ( | PresentationContext | presentationContext,
|  | PropertyAnimation * | propertyAnimation )

## addRunString()

void osgPresentation::SlideShowConstructor::addRunString | ( | osg::Node * | node,
|  | const std::string & | runString )

inline

References getOrCreateLayerAttributes().

Referenced by addLayerRunString(), addPresentationRunString(), and addSlideRunString().

## addScript()

void osgPresentation::SlideShowConstructor::addScript | ( | const std::string & | name,
|  | const std::string & | language,
|  | const std::string & | script )

## addScriptCallback()

void osgPresentation::SlideShowConstructor::addScriptCallback | ( | PresentationContext | presentationContext,
|  | ScriptCallbackType | scriptCallbackType,
|  | const std::string & | functionName )

## addScriptEngine()

void osgPresentation::SlideShowConstructor::addScriptEngine | ( | const std::string & | scriptEngineName | ) |

## addScriptFile()

void osgPresentation::SlideShowConstructor::addScriptFile | ( | const std::string & | name,
|  | const std::string & | filename )

## addScriptsToNode()

void osgPresentation::SlideShowConstructor::addScriptsToNode | ( | const ScriptData & | scriptData,
|  | osg::Node * | node )

## addScriptToNode()

void osgPresentation::SlideShowConstructor::addScriptToNode | ( | ScriptCallbackType | scriptCallbackType,
|  | const std::string & | name,
|  | osg::Node * | node )

## addSlide()

void osgPresentation::SlideShowConstructor::addSlide | ( |  | ) |

Referenced by addSlideKey(), addSlideRunString(), and setSlideJump().

## addSlideKey()

void osgPresentation::SlideShowConstructor::addSlideKey | ( | const KeyPosition & | kp | ) |

inline

References _slide, addKey(), and addSlide().

## addSlideRunString()

void osgPresentation::SlideShowConstructor::addSlideRunString | ( | const std::string & | runString | ) |

inline

References _slide, addRunString(), and addSlide().

## addStereoImagePair()

void osgPresentation::SlideShowConstructor::addStereoImagePair | ( | const std::string & | filenameLeft,
|  | const ImageData & | imageDataLeft,
|  | const std::string & | filenameRight,
|  | const ImageData & | imageDataRight,
|  | const PositionData & | positionData,
|  | const ScriptData & | scriptData )

## addTimeout()

Timeout * osgPresentation::SlideShowConstructor::addTimeout | ( |  | ) |

## addToCurrentLayer()

void osgPresentation::SlideShowConstructor::addToCurrentLayer | ( | osg::Node * | subgraph | ) |

## addVNC()

void osgPresentation::SlideShowConstructor::addVNC | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const ImageData & | imageData,
|  | const std::string & | password,
|  | const ScriptData & | scriptData )

## addVolume()

void osgPresentation::SlideShowConstructor::addVolume | ( | const std::string & | filename,
|  | const PositionData & | positionData,
|  | const VolumeData & | volumeData,
|  | const ScriptData & | scriptData )

## attachMaterialAnimation()

osg::Node * osgPresentation::SlideShowConstructor::attachMaterialAnimation | ( | osg::Node * | model,
|  | const PositionData & | positionData )

protected

## attachTexMat()

bool osgPresentation::SlideShowConstructor::attachTexMat | ( | osg::StateSet * | stateset,
|  | const ImageData & | imageData,
|  | float | s,
|  | float | t,
|  | bool | textureRectangle )

protected

## computePositionInModelCoords()

osg::Vec3 osgPresentation::SlideShowConstructor::computePositionInModelCoords | ( | const PositionData & | positionData | ) | const

protected

## convertModelToSlide()

osg::Vec3 osgPresentation::SlideShowConstructor::convertModelToSlide | ( | const osg::Vec3 & | position | ) | const

protected

## convertSlideToModel()

osg::Vec3 osgPresentation::SlideShowConstructor::convertSlideToModel | ( | const osg::Vec3 & | position | ) | const

protected

## createPresentation()

void osgPresentation::SlideShowConstructor::createPresentation | ( |  | ) |

Referenced by addPresentationKey(), and addPresentationRunString().

## createTexturedQuadGeometry()

osg::Geometry * osgPresentation::SlideShowConstructor::createTexturedQuadGeometry | ( | const osg::Vec3 & | pos,
|  | const osg::Vec4 & | rotation,
|  | float | width,
|  | float | height,
|  | osg::Image * | image,
|  | bool & | usedTextureRectangle )

protected

## createTransformStateSet()

osg::StateSet * osgPresentation::SlideShowConstructor::createTransformStateSet | ( |  | ) |

inline protected

References GL_NORMALIZE, osg::StateAttribute::ON, and osg::StateSet::setMode().

## decorateSubgraphForPosition()

osg::Node * osgPresentation::SlideShowConstructor::decorateSubgraphForPosition | ( | osg::Node * | node,
|  | PositionData & | positionData )

protected

## decorateSubgraphForPositionAndAnimation()

osg::Node * osgPresentation::SlideShowConstructor::decorateSubgraphForPositionAndAnimation | ( | osg::Node * | node,
|  | const PositionData & | positionData )

protected

## findFileAndRecordPath()

std::string osgPresentation::SlideShowConstructor::findFileAndRecordPath | ( | const std::string & | filename | ) |

protected

## findImageStreamsAndAddCallbacks()

void osgPresentation::SlideShowConstructor::findImageStreamsAndAddCallbacks | ( | osg::Node * | node | ) |

protected

## getAnimationPathCallback()

osg::AnimationPathCallback * osgPresentation::SlideShowConstructor::getAnimationPathCallback | ( | const PositionData & | positionData | ) |

protected

## getAutoSteppingActive()

bool osgPresentation::SlideShowConstructor::getAutoSteppingActive | ( |  | ) | const

inline

References _autoSteppingActive.

## getBackgroundColor()

const osg::Vec4 & osgPresentation::SlideShowConstructor::getBackgroundColor | ( |  | ) | const

inline

References _backgroundColor.

## getCurrentLayer()

osg::Group * osgPresentation::SlideShowConstructor::getCurrentLayer | ( |  | ) |

inline

References _currentLayer.

## getCurrentSlide()

osg::Switch * osgPresentation::SlideShowConstructor::getCurrentSlide | ( |  | ) |

inline

References _slide.

## getHUDSettings() [1/2]

HUDSettings * osgPresentation::SlideShowConstructor::getHUDSettings | ( |  | ) |

inline

References _hudSettings.

## getHUDSettings() [2/2]

const HUDSettings * osgPresentation::SlideShowConstructor::getHUDSettings | ( |  | ) | const

inline

References _hudSettings.

## getImagePositionData()

PositionData & osgPresentation::SlideShowConstructor::getImagePositionData | ( |  | ) |

inline

References _imagePositionData.

## getImagePositionDataDefault()

PositionData & osgPresentation::SlideShowConstructor::getImagePositionDataDefault | ( |  | ) |

inline

References _imagePositionDataDefault.

## getLoopPresentation()

bool osgPresentation::SlideShowConstructor::getLoopPresentation | ( |  | ) | const

inline

References _loopPresentation.

## getModelPositionData()

PositionData & osgPresentation::SlideShowConstructor::getModelPositionData | ( |  | ) |

inline

References _modelPositionData.

## getModelPositionDataDefault()

PositionData & osgPresentation::SlideShowConstructor::getModelPositionDataDefault | ( |  | ) |

inline

References _modelPositionDataDefault.

## getOrCreateLayerAttributes()

LayerAttributes * osgPresentation::SlideShowConstructor::getOrCreateLayerAttributes | ( | osg::Node * | node | ) |

Referenced by addKey(), addRunString(), setDuration(), and setJump().

## getOrCreateScriptEngine()

osg::ScriptEngine * osgPresentation::SlideShowConstructor::getOrCreateScriptEngine | ( | const std::string & | language | ) |

## getPresentation()

osg::Group * osgPresentation::SlideShowConstructor::getPresentation | ( |  | ) |

inline

References _root.

## getPresentationSwitch()

osg::Switch * osgPresentation::SlideShowConstructor::getPresentationSwitch | ( |  | ) |

inline

References _presentationSwitch.

## getTextColor()

const osg::Vec4 & osgPresentation::SlideShowConstructor::getTextColor | ( |  | ) | const

inline

References _textFontDataDefault.

## getTextFontData()

FontData & osgPresentation::SlideShowConstructor::getTextFontData | ( |  | ) |

inline

References _textFontData.

## getTextFontDataDefault()

FontData & osgPresentation::SlideShowConstructor::getTextFontDataDefault | ( |  | ) |

inline

References _textFontDataDefault.

## getTextPositionData()

PositionData & osgPresentation::SlideShowConstructor::getTextPositionData | ( |  | ) |

inline

References _textPositionData.

## getTextPositionDataDefault()

PositionData & osgPresentation::SlideShowConstructor::getTextPositionDataDefault | ( |  | ) |

inline

References _textPositionDataDefault.

## getTitleFontData()

FontData & osgPresentation::SlideShowConstructor::getTitleFontData | ( |  | ) |

inline

References _titleFontData.

## getTitleFontDataDefault()

FontData & osgPresentation::SlideShowConstructor::getTitleFontDataDefault | ( |  | ) |

inline

References _titleFontDataDefault.

## getTitlePositionData()

PositionData & osgPresentation::SlideShowConstructor::getTitlePositionData | ( |  | ) |

inline

References _titlePositionData.

## getTitlePositionDataDefault()

PositionData & osgPresentation::SlideShowConstructor::getTitlePositionDataDefault | ( |  | ) |

inline

References _titlePositionDataDefault.

## keyEventOperation()

void osgPresentation::SlideShowConstructor::keyEventOperation | ( | PresentationContext | presentationContext,
|  | int | key,
|  | const KeyPosition & | keyPos,
|  | const JumpData & | jumpData = JumpData() )

## keyToDoOperation() [1/2]

void osgPresentation::SlideShowConstructor::keyToDoOperation | ( | PresentationContext | presentationContext,
|  | int | key,
|  | const std::string & | command,
|  | Operation | operation,
|  | const JumpData & | jumpData = JumpData() )

## keyToDoOperation() [2/2]

void osgPresentation::SlideShowConstructor::keyToDoOperation | ( | PresentationContext | presentationContext,
|  | int | key,
|  | Operation | operation,
|  | const JumpData & | jumpData = JumpData() )

## layerClickEventOperation()

void osgPresentation::SlideShowConstructor::layerClickEventOperation | ( | const KeyPosition & | keyPos,
|  | const JumpData & | jumpData = JumpData() )

## layerClickToDoOperation() [1/2]

void osgPresentation::SlideShowConstructor::layerClickToDoOperation | ( | const std::string & | command,
|  | Operation | operation,
|  | const JumpData & | jumpData = JumpData() )

## layerClickToDoOperation() [2/2]

void osgPresentation::SlideShowConstructor::layerClickToDoOperation | ( | Operation | operation,
|  | const JumpData & | jumpData = JumpData() )

## popCurrentLayer()

void osgPresentation::SlideShowConstructor::popCurrentLayer | ( |  | ) |

## pushCurrentLayer()

void osgPresentation::SlideShowConstructor::pushCurrentLayer | ( | osg::Group * | newLayerGroup | ) |

## readImage()

osg::ref_ptr< osg::Image > osgPresentation::SlideShowConstructor::readImage | ( | const std::string & | filename,
|  | const ImageData & | imageData )

## recordOptionsFilePath()

void osgPresentation::SlideShowConstructor::recordOptionsFilePath | ( | const osgDB::Options * | options | ) |

protected

## selectLayer()

void osgPresentation::SlideShowConstructor::selectLayer | ( | int | layerNum | ) |

## selectSlide()

void osgPresentation::SlideShowConstructor::selectSlide | ( | int | slideNum | ) |

## setAutoSteppingActive()

void osgPresentation::SlideShowConstructor::setAutoSteppingActive | ( | bool | flag = true | ) |

inline

References _autoSteppingActive.

## setBackgroundColor()

void osgPresentation::SlideShowConstructor::setBackgroundColor | ( | const osg::Vec4 & | color,
|  | bool | updateClearNode )

## setDuration()

void osgPresentation::SlideShowConstructor::setDuration | ( | osg::Node * | node,
|  | double | duration )

inline

References getOrCreateLayerAttributes().

## setHUDSettings()

void osgPresentation::SlideShowConstructor::setHUDSettings | ( | HUDSettings * | hudSettings | ) |

inline

References _hudSettings.

## setJump()

void osgPresentation::SlideShowConstructor::setJump | ( | osg::Node * | node,
|  | const JumpData & | jumpData )

inline

References getOrCreateLayerAttributes().

Referenced by setLayerJump(), and setSlideJump().

## setLayerDuration()

void osgPresentation::SlideShowConstructor::setLayerDuration | ( | double | duration | ) |

## setLayerJump()

void osgPresentation::SlideShowConstructor::setLayerJump | ( | const JumpData & | jumpData | ) |

inline

References _currentLayer, addLayer(), and setJump().

## setLoopPresentation()

void osgPresentation::SlideShowConstructor::setLoopPresentation | ( | bool | loop | ) |

inline

References _loopPresentation.

## setPresentationAspectRatio() [1/2]

void osgPresentation::SlideShowConstructor::setPresentationAspectRatio | ( | const std::string & | str | ) |

## setPresentationAspectRatio() [2/2]

void osgPresentation::SlideShowConstructor::setPresentationAspectRatio | ( | float | aspectRatio | ) |

## setPresentationDuration()

void osgPresentation::SlideShowConstructor::setPresentationDuration | ( | double | duration | ) |

## setPresentationName()

void osgPresentation::SlideShowConstructor::setPresentationName | ( | const std::string & | name | ) |

## setSlideBackgrondHUD()

void osgPresentation::SlideShowConstructor::setSlideBackgrondHUD | ( | bool | hud | ) |

inline

References _slideBackgroundAsHUD.

## setSlideBackground()

void osgPresentation::SlideShowConstructor::setSlideBackground | ( | const std::string & | name | ) |

inline

References _slideBackgroundImageFileName.

## setSlideDuration()

void osgPresentation::SlideShowConstructor::setSlideDuration | ( | double | duration | ) |

## setSlideJump()

void osgPresentation::SlideShowConstructor::setSlideJump | ( | const JumpData & | jumpData | ) |

inline

References _slide, addSlide(), and setJump().

## setSlideTitle()

void osgPresentation::SlideShowConstructor::setSlideTitle | ( | const std::string & | name,
|  | PositionData & | positionData,
|  | FontData & | fontData )

inline

References _slideTitle, _titleFontData, and _titlePositionData.

## setTextColor()

void osgPresentation::SlideShowConstructor::setTextColor | ( | const osg::Vec4 & | color | ) |

## setUpMovieVolume()

void osgPresentation::SlideShowConstructor::setUpMovieVolume | ( | osg::Node * | subgraph,
|  | osg::ImageStream * | imageStream,
|  | const ImageData & | imageData )

protected

## setUpVolumeScalarProperty()

void osgPresentation::SlideShowConstructor::setUpVolumeScalarProperty | ( | osgVolume::VolumeTile * | tile,
|  | osgVolume::ScalarProperty * | property,
|  | const std::string & | source )

## takePresentation()

osg::Group * osgPresentation::SlideShowConstructor::takePresentation | ( |  | ) |

inline

References _root.

## translateTextCursor()

void osgPresentation::SlideShowConstructor::translateTextCursor | ( | const osg::Vec3 & | delta | ) |

inline

References _textPositionData.

## updatePositionFromInModelCoords()

void osgPresentation::SlideShowConstructor::updatePositionFromInModelCoords | ( | const osg::Vec3 & | vertex,
|  | PositionData & | positionData ) const

protected

## Member Data Documentation

## _autoSteppingActive

bool osgPresentation::SlideShowConstructor::_autoSteppingActive

protected

Referenced by getAutoSteppingActive(), and setAutoSteppingActive().

## _backgroundColor

osg::Vec4 osgPresentation::SlideShowConstructor::_backgroundColor

protected

Referenced by getBackgroundColor().

## _currentEventCallbacksToApply

EventHandlerList osgPresentation::SlideShowConstructor::_currentEventCallbacksToApply

protected

## _currentLayer

osg::ref_ptr<osg::Group> osgPresentation::SlideShowConstructor::_currentLayer

protected

Referenced by addLayerKey(), addLayerRunString(), getCurrentLayer(), and setLayerJump().

## _eyeOrigin

osg::Vec3 osgPresentation::SlideShowConstructor::_eyeOrigin

protected

## _filePathData

osg::ref_ptr<FilePathData> osgPresentation::SlideShowConstructor::_filePathData

protected

## _hudSettings

osg::ref_ptr<HUDSettings> osgPresentation::SlideShowConstructor::_hudSettings

protected

Referenced by getHUDSettings(), getHUDSettings(), and setHUDSettings().

## _imagePositionData

PositionData osgPresentation::SlideShowConstructor::_imagePositionData

protected

Referenced by getImagePositionData().

## _imagePositionDataDefault

PositionData osgPresentation::SlideShowConstructor::_imagePositionDataDefault

protected

Referenced by getImagePositionDataDefault().

## _layerStack

LayerStack osgPresentation::SlideShowConstructor::_layerStack

protected

## _layerToApplyEventCallbackTo

osg::ref_ptr<osg::Group> osgPresentation::SlideShowConstructor::_layerToApplyEventCallbackTo

protected

## _leftEyeMask

unsigned int osgPresentation::SlideShowConstructor::_leftEyeMask

protected

## _loopPresentation

bool osgPresentation::SlideShowConstructor::_loopPresentation

protected

Referenced by getLoopPresentation(), and setLoopPresentation().

## _modelPositionData

PositionData osgPresentation::SlideShowConstructor::_modelPositionData

protected

Referenced by getModelPositionData().

## _modelPositionDataDefault

PositionData osgPresentation::SlideShowConstructor::_modelPositionDataDefault

protected

Referenced by getModelPositionDataDefault().

## _options

osg::ref_ptr<osgDB::Options> osgPresentation::SlideShowConstructor::_options

protected

## _presentationDuration

double osgPresentation::SlideShowConstructor::_presentationDuration

protected

## _presentationName

std::string osgPresentation::SlideShowConstructor::_presentationName

protected

## _presentationSwitch

osg::ref_ptr<osg::Switch> osgPresentation::SlideShowConstructor::_presentationSwitch

protected

Referenced by addPresentationKey(), addPresentationRunString(), and getPresentationSwitch().

## _previousLayer

osg::ref_ptr<osg::Group> osgPresentation::SlideShowConstructor::_previousLayer

protected

## _propertyEventCallback

osg::ref_ptr<osgPresentation::PropertyEventCallback> osgPresentation::SlideShowConstructor::_propertyEventCallback

protected

## _propertyManager

osg::ref_ptr<osgPresentation::PropertyManager> osgPresentation::SlideShowConstructor::_propertyManager

protected

## _rightEyeMask

unsigned int osgPresentation::SlideShowConstructor::_rightEyeMask

protected

## _root

osg::ref_ptr<osg::Group> osgPresentation::SlideShowConstructor::_root

protected

Referenced by getPresentation(), and takePresentation().

## _scriptEngines

ScriptEngineMap osgPresentation::SlideShowConstructor::_scriptEngines

protected

## _scripts

ScriptMap osgPresentation::SlideShowConstructor::_scripts

protected

## _slide

osg::ref_ptr<osg::Switch> osgPresentation::SlideShowConstructor::_slide

protected

Referenced by addSlideKey(), addSlideRunString(), getCurrentSlide(), and setSlideJump().

## _slideBackgroundAsHUD

bool osgPresentation::SlideShowConstructor::_slideBackgroundAsHUD

protected

Referenced by setSlideBackgrondHUD().

## _slideBackgroundImageFileName

std::string osgPresentation::SlideShowConstructor::_slideBackgroundImageFileName

protected

Referenced by setSlideBackground().

## _slideClearNode

osg::ref_ptr<osg::ClearNode> osgPresentation::SlideShowConstructor::_slideClearNode

protected

## _slideDistance

double osgPresentation::SlideShowConstructor::_slideDistance

protected

## _slideHeight

double osgPresentation::SlideShowConstructor::_slideHeight

protected

## _slideOrigin

osg::Vec3 osgPresentation::SlideShowConstructor::_slideOrigin

protected

## _slideTitle

std::string osgPresentation::SlideShowConstructor::_slideTitle

protected

Referenced by setSlideTitle().

## _slideWidth

double osgPresentation::SlideShowConstructor::_slideWidth

protected

## _textFontData

FontData osgPresentation::SlideShowConstructor::_textFontData

protected

Referenced by getTextFontData().

## _textFontDataDefault

FontData osgPresentation::SlideShowConstructor::_textFontDataDefault

protected

Referenced by getTextColor(), and getTextFontDataDefault().

## _textPositionData

PositionData osgPresentation::SlideShowConstructor::_textPositionData

protected

Referenced by getTextPositionData(), and translateTextCursor().

## _textPositionDataDefault

PositionData osgPresentation::SlideShowConstructor::_textPositionDataDefault

protected

Referenced by getTextPositionDataDefault().

## _titleFontData

FontData osgPresentation::SlideShowConstructor::_titleFontData

protected

Referenced by getTitleFontData(), and setSlideTitle().

## _titleFontDataDefault

FontData osgPresentation::SlideShowConstructor::_titleFontDataDefault

protected

Referenced by getTitleFontDataDefault().

## _titlePositionData

PositionData osgPresentation::SlideShowConstructor::_titlePositionData

protected

Referenced by getTitlePositionData(), and setSlideTitle().

## _titlePositionDataDefault

PositionData osgPresentation::SlideShowConstructor::_titlePositionDataDefault

protected

Referenced by getTitlePositionDataDefault().

The documentation for this class was generated from the following file:

- SlideShowConstructor